#include <stdio.h>
#include <string.h>

#define FILENAMELENGTH 100
#define LINE for(i=0;i<80;i++)printf("-");printf("\n")

/* CHANGE THESE FOR OTHER VICE VERSIONS MAYBE */
#define VICOFFSET 0x48d
#define CIAOFFSET 0x16


int main(int argc, char **argv)
  {
unsigned char basic[]={0x01,0x08,0x13,0x08,0x00,0x00,0x9e,0x32,0x30,0x36,0x39,\
0x20,0x45,0x4e,0x54,0x48,0x55,0x53,0x49,0x00,0x00,0x00,0xa9,0x00,0x8d,0x20,0xd0,\
0xa9,0xff,0x8d,0x00,0xdd,0xa9,0x3b,0x8d,0x11,0xd0,0xa9,0x38,0x8d,0x18,0xd0,0x4c,0x29,0x08};

FILE *vsf_file;
FILE *map_file;
FILE *col_file;
FILE *prg_file;

unsigned char value_d018,value_dd00,byte,v1,v2,v3,v4;
int i,bank,map,bitmap,file_end,pos_d018, pos_dd00;

char bitmap_name[FILENAMELENGTH];
char colmap_name[FILENAMELENGTH];
char prg_name[FILENAMELENGTH];

if(argc<2) {LINE;printf("VSF HiRes grabber by enthusi/onslaught.\nSave VICE snapshot during display of HiRes-Bitmap.\n\
No error handling =D\nSyntax: '%s ViceSnapshotFile.vsf'.\n",argv[0]);LINE;return -1;}

//argv[1][strlen(argv[1])-4]='\0';
sprintf(bitmap_name,"%s.bitmap",argv[1]);
sprintf(colmap_name,"%s.colmap",argv[1]);
sprintf(prg_name,"%s.prg",argv[1]);

if (!(vsf_file = fopen(argv[1], "r"))){printf("Cant't open snapshot file '%s'!\n",argv[1]);return -1;};
if (!(map_file = fopen(bitmap_name, "w"))){printf("Cant't write bitmap file '%s'!\n",bitmap_name);return -1;};
if (!(col_file = fopen(colmap_name, "w"))){printf("Cant't write colmap file '%s'!\n",colmap_name);return -1;};
if (!(prg_file = fopen(prg_name, "w"))){printf("Cant't write PRG file '%s'!\n",prg_name);return -1;};

fseek(vsf_file,0,SEEK_END);file_end = ftell(vsf_file);

for(i=0;i<file_end;i++)
  {fseek(vsf_file,i,SEEK_SET);v1=fgetc(vsf_file);v2=fgetc(vsf_file);v3=fgetc(vsf_file);v4=fgetc(vsf_file);
  if((v1=='V')&&(v2=='I')&&(v3=='C')&&(v4=='-')) pos_d018=i+VICOFFSET;
  if((v1=='C')&&(v2=='I')&&(v3=='A')&&(v4=='2')) pos_dd00=i+CIAOFFSET;}

fseek(vsf_file,pos_dd00,SEEK_SET);
value_dd00=fgetc(vsf_file);
fseek(vsf_file,pos_d018,SEEK_SET);
value_d018=fgetc(vsf_file);
bank = 0xc000-(value_dd00 & 3)*0x4000;
bitmap = ((value_d018>>3)&1)*0x2000+bank;
map = (value_d018>>4)*0x0400+bank;

LINE;
printf("Using HiRes Bitmap in Bank $%04x ($%02x).\n",bank,value_dd00);
printf("BitMap at $%04x\t\twritten as '%s' without header.\n",bitmap,bitmap_name);
printf("ColMap at $%04x ($%02x)\twritten as '%s' without header.\n",map,value_d018,colmap_name);
printf("Executable HiRes-Viewer\twritten as '%s'.\n",prg_name);
LINE;

fwrite(&basic,sizeof(basic),1,prg_file);
for(i=0;i<980;i++) {fputc(0,prg_file);}

fseek(vsf_file,0x80+map,SEEK_SET);
for(i=0;i<1000;i++) {byte=fgetc(vsf_file);fputc(byte,col_file);fputc(byte,prg_file);}

for(i=0;i<4120;i++) {fputc(0,prg_file);}

fseek(vsf_file,0x80+bitmap,SEEK_SET);
for(i=0;i<8000;i++) {byte=fgetc(vsf_file);fputc(byte,map_file);fputc(byte,prg_file);}

return 0;
}
